//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the semanticmodel package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __semanticmodel__FILTERCONFIG_H__
#define __semanticmodel__FILTERCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace semanticmodel
{
  class FilterConfigStatics;
  
  class FilterConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(FilterConfig &config, const FilterConfig &max, const FilterConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const FilterConfig &config1, const FilterConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, FilterConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const FilterConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, FilterConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const FilterConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T FilterConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (FilterConfig::* field);

      virtual void clamp(FilterConfig &config, const FilterConfig &max, const FilterConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const FilterConfig &config1, const FilterConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, FilterConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const FilterConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, FilterConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const FilterConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 15 "../cfg/Filter.cfg"
      std::string canonical_frame;
//#line 21 "../cfg/Filter.cfg"
      double min_z;
//#line 28 "../cfg/Filter.cfg"
      double max_z;
//#line 34 "../cfg/Filter.cfg"
      double voxel_size;
//#line 40 "../cfg/Filter.cfg"
      int ransac_iterations;
//#line 46 "../cfg/Filter.cfg"
      double plane_tolerance;
//#line 52 "../cfg/Filter.cfg"
      double horizontal_dot;
//#line 58 "../cfg/Filter.cfg"
      double k_radius;
//#line 64 "../cfg/Filter.cfg"
      int k_n;
//#line 71 "../cfg/Filter.cfg"
      double plane_cluster_tolerance;
//#line 77 "../cfg/Filter.cfg"
      int plane_min_cluster_size;
//#line 84 "../cfg/Filter.cfg"
      int plane_max_cluster_size;
//#line 90 "../cfg/Filter.cfg"
      double plane_distance;
//#line 96 "../cfg/Filter.cfg"
      int number_of_clusters;
//#line 102 "../cfg/Filter.cfg"
      double filter_lag_cutoff;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("FilterConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const FilterConfig &__max__ = __getMax__();
      const FilterConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const FilterConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const FilterConfig &__getDefault__();
    static const FilterConfig &__getMax__();
    static const FilterConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const FilterConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void FilterConfig::ParamDescription<std::string>::clamp(FilterConfig &config, const FilterConfig &max, const FilterConfig &min) const
  {
    return;
  }

  class FilterConfigStatics
  {
    friend class FilterConfig;
    
    FilterConfigStatics()
    {
//#line 15 "../cfg/Filter.cfg"
      __min__.canonical_frame = "";
//#line 15 "../cfg/Filter.cfg"
      __max__.canonical_frame = "";
//#line 15 "../cfg/Filter.cfg"
      __default__.canonical_frame = "/map";
//#line 15 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<std::string>("canonical_frame", "str", 0, "The frame in which we work (for {low, high}_z, for example).", "", &FilterConfig::canonical_frame)));
//#line 21 "../cfg/Filter.cfg"
      __min__.min_z = -5.0;
//#line 21 "../cfg/Filter.cfg"
      __max__.min_z = 5.0;
//#line 21 "../cfg/Filter.cfg"
      __default__.min_z = 0.6;
//#line 21 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<double>("min_z", "double", 0, "Filter out all points below this value.", "", &FilterConfig::min_z)));
//#line 28 "../cfg/Filter.cfg"
      __min__.max_z = -5.0;
//#line 28 "../cfg/Filter.cfg"
      __max__.max_z = 5.0;
//#line 28 "../cfg/Filter.cfg"
      __default__.max_z = 1.8;
//#line 28 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<double>("max_z", "double", 0, "Filter out all points above this value.", "", &FilterConfig::max_z)));
//#line 34 "../cfg/Filter.cfg"
      __min__.voxel_size = 0.01;
//#line 34 "../cfg/Filter.cfg"
      __max__.voxel_size = 1.0;
//#line 34 "../cfg/Filter.cfg"
      __default__.voxel_size = 0.06;
//#line 34 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<double>("voxel_size", "double", 0, "Size of the voxels in the voxel grid, in meters.", "", &FilterConfig::voxel_size)));
//#line 40 "../cfg/Filter.cfg"
      __min__.ransac_iterations = 1;
//#line 40 "../cfg/Filter.cfg"
      __max__.ransac_iterations = 1000;
//#line 40 "../cfg/Filter.cfg"
      __default__.ransac_iterations = 500;
//#line 40 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<int>("ransac_iterations", "int", 0, "How much RANSAC to do when finding planes.", "", &FilterConfig::ransac_iterations)));
//#line 46 "../cfg/Filter.cfg"
      __min__.plane_tolerance = 0.001;
//#line 46 "../cfg/Filter.cfg"
      __max__.plane_tolerance = 1.0;
//#line 46 "../cfg/Filter.cfg"
      __default__.plane_tolerance = 0.01;
//#line 46 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<double>("plane_tolerance", "double", 0, "Distance Threshold for plane fitter.", "", &FilterConfig::plane_tolerance)));
//#line 52 "../cfg/Filter.cfg"
      __min__.horizontal_dot = 0.0;
//#line 52 "../cfg/Filter.cfg"
      __max__.horizontal_dot = 1.0;
//#line 52 "../cfg/Filter.cfg"
      __default__.horizontal_dot = 0.999;
//#line 52 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<double>("horizontal_dot", "double", 0, "Lowest permissable dot product (with +z) for horizontal", "", &FilterConfig::horizontal_dot)));
//#line 58 "../cfg/Filter.cfg"
      __min__.k_radius = 0.01;
//#line 58 "../cfg/Filter.cfg"
      __max__.k_radius = 10.0;
//#line 58 "../cfg/Filter.cfg"
      __default__.k_radius = 0.25;
//#line 58 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<double>("k_radius", "double", 0, "Radius for KNN erosion.", "", &FilterConfig::k_radius)));
//#line 64 "../cfg/Filter.cfg"
      __min__.k_n = 1;
//#line 64 "../cfg/Filter.cfg"
      __max__.k_n = 5000;
//#line 64 "../cfg/Filter.cfg"
      __default__.k_n = 25;
//#line 64 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<int>("k_n", "int", 0, "Number of neighbors for KNN erosion.", "", &FilterConfig::k_n)));
//#line 71 "../cfg/Filter.cfg"
      __min__.plane_cluster_tolerance = 0.01;
//#line 71 "../cfg/Filter.cfg"
      __max__.plane_cluster_tolerance = 1.0;
//#line 71 "../cfg/Filter.cfg"
      __default__.plane_cluster_tolerance = 0.1;
//#line 71 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<double>("plane_cluster_tolerance", "double", 0, "Cluster tolerance for planes.", "", &FilterConfig::plane_cluster_tolerance)));
//#line 77 "../cfg/Filter.cfg"
      __min__.plane_min_cluster_size = 1;
//#line 77 "../cfg/Filter.cfg"
      __max__.plane_min_cluster_size = 10000;
//#line 77 "../cfg/Filter.cfg"
      __default__.plane_min_cluster_size = 50;
//#line 77 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<int>("plane_min_cluster_size", "int", 0, "Minimum cluster size for plane clustering.", "", &FilterConfig::plane_min_cluster_size)));
//#line 84 "../cfg/Filter.cfg"
      __min__.plane_max_cluster_size = 1;
//#line 84 "../cfg/Filter.cfg"
      __max__.plane_max_cluster_size = 50000;
//#line 84 "../cfg/Filter.cfg"
      __default__.plane_max_cluster_size = 10000;
//#line 84 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<int>("plane_max_cluster_size", "int", 0, "Maximum cluster size for plane clustering.", "", &FilterConfig::plane_max_cluster_size)));
//#line 90 "../cfg/Filter.cfg"
      __min__.plane_distance = 0.0;
//#line 90 "../cfg/Filter.cfg"
      __max__.plane_distance = 1.0;
//#line 90 "../cfg/Filter.cfg"
      __default__.plane_distance = 0.05;
//#line 90 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<double>("plane_distance", "double", 0, "How far off the plane do we need to be?", "", &FilterConfig::plane_distance)));
//#line 96 "../cfg/Filter.cfg"
      __min__.number_of_clusters = 0;
//#line 96 "../cfg/Filter.cfg"
      __max__.number_of_clusters = 1000;
//#line 96 "../cfg/Filter.cfg"
      __default__.number_of_clusters = 1;
//#line 96 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<int>("number_of_clusters", "int", 0, "How many (object) clusters do we show?", "", &FilterConfig::number_of_clusters)));
//#line 102 "../cfg/Filter.cfg"
      __min__.filter_lag_cutoff = 0.0;
//#line 102 "../cfg/Filter.cfg"
      __max__.filter_lag_cutoff = 60.0;
//#line 102 "../cfg/Filter.cfg"
      __default__.filter_lag_cutoff = 2.0;
//#line 102 "../cfg/Filter.cfg"
      __param_descriptions__.push_back(FilterConfig::AbstractParamDescriptionConstPtr(new FilterConfig::ParamDescription<double>("filter_lag_cutoff", "double", 0, "If a frame is more than N seconds old, drop it on the floor.", "", &FilterConfig::filter_lag_cutoff)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<FilterConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<FilterConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    FilterConfig __max__;
    FilterConfig __min__;
    FilterConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const FilterConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static FilterConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &FilterConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const FilterConfig &FilterConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const FilterConfig &FilterConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const FilterConfig &FilterConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<FilterConfig::AbstractParamDescriptionConstPtr> &FilterConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const FilterConfigStatics *FilterConfig::__get_statics__()
  {
    const static FilterConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = FilterConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __FILTERRECONFIGURATOR_H__
