//#line 2 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
// *********************************************************
// 
// File autogenerated for the semanticmodel package 
// by the dynamic_reconfigure package.
// Please do not edit.
// 
// ********************************************************/

/***********************************************************
 * Software License Agreement (BSD License)
 *
 *  Copyright (c) 2008, Willow Garage, Inc.
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of the Willow Garage nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 *  FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 *  COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 *  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 *  BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 *  LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 *  CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 *  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 *  ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 *  POSSIBILITY OF SUCH DAMAGE.
 ***********************************************************/

// Author: Blaise Gassend


#ifndef __semanticmodel__OBJECTTRACKERCONFIG_H__
#define __semanticmodel__OBJECTTRACKERCONFIG_H__

#include <dynamic_reconfigure/config_tools.h>
#include <limits>
#include <ros/node_handle.h>
#include <dynamic_reconfigure/ConfigDescription.h>
#include <dynamic_reconfigure/ParamDescription.h>
#include <dynamic_reconfigure/config_init_mutex.h>

namespace semanticmodel
{
  class ObjectTrackerConfigStatics;
  
  class ObjectTrackerConfig
  {
  public:
    class AbstractParamDescription : public dynamic_reconfigure::ParamDescription
    {
    public:
      AbstractParamDescription(std::string n, std::string t, uint32_t l, 
          std::string d, std::string e)
      {
        name = n;
        type = t;
        level = l;
        description = d;
        edit_method = e;
      }
      
      virtual void clamp(ObjectTrackerConfig &config, const ObjectTrackerConfig &max, const ObjectTrackerConfig &min) const = 0;
      virtual void calcLevel(uint32_t &level, const ObjectTrackerConfig &config1, const ObjectTrackerConfig &config2) const = 0;
      virtual void fromServer(const ros::NodeHandle &nh, ObjectTrackerConfig &config) const = 0;
      virtual void toServer(const ros::NodeHandle &nh, const ObjectTrackerConfig &config) const = 0;
      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, ObjectTrackerConfig &config) const = 0;
      virtual void toMessage(dynamic_reconfigure::Config &msg, const ObjectTrackerConfig &config) const = 0;
    };

    typedef boost::shared_ptr<AbstractParamDescription> AbstractParamDescriptionPtr;
    typedef boost::shared_ptr<const AbstractParamDescription> AbstractParamDescriptionConstPtr;
    
    template <class T>
    class ParamDescription : public AbstractParamDescription
    {
    public:
      ParamDescription(std::string name, std::string type, uint32_t level, 
          std::string description, std::string edit_method, T ObjectTrackerConfig::* f) :
        AbstractParamDescription(name, type, level, description, edit_method),
        field(f)
      {}

      T (ObjectTrackerConfig::* field);

      virtual void clamp(ObjectTrackerConfig &config, const ObjectTrackerConfig &max, const ObjectTrackerConfig &min) const
      {
        if (config.*field > max.*field)
          config.*field = max.*field;
        
        if (config.*field < min.*field)
          config.*field = min.*field;
      }

      virtual void calcLevel(uint32_t &comb_level, const ObjectTrackerConfig &config1, const ObjectTrackerConfig &config2) const
      {
        if (config1.*field != config2.*field)
          comb_level |= level;
      }

      virtual void fromServer(const ros::NodeHandle &nh, ObjectTrackerConfig &config) const
      {
        nh.getParam(name, config.*field);
      }

      virtual void toServer(const ros::NodeHandle &nh, const ObjectTrackerConfig &config) const
      {
        nh.setParam(name, config.*field);
      }

      virtual bool fromMessage(const dynamic_reconfigure::Config &msg, ObjectTrackerConfig &config) const
      {
        return dynamic_reconfigure::ConfigTools::getParameter(msg, name, config.*field);
      }

      virtual void toMessage(dynamic_reconfigure::Config &msg, const ObjectTrackerConfig &config) const
      {
        dynamic_reconfigure::ConfigTools::appendParameter(msg, name, config.*field);
      }
    };

//#line 14 "../cfg/ObjectTracker.cfg"
      std::string canonical_frame;
//#line 20 "../cfg/ObjectTracker.cfg"
      bool false_color;
//#line 26 "../cfg/ObjectTracker.cfg"
      bool send_boxes;
//#line 32 "../cfg/ObjectTracker.cfg"
      double cluster_tolerance;
//#line 38 "../cfg/ObjectTracker.cfg"
      int min_cluster_size;
//#line 44 "../cfg/ObjectTracker.cfg"
      int max_cluster_size;
//#line 50 "../cfg/ObjectTracker.cfg"
      double occ_trick_low;
//#line 56 "../cfg/ObjectTracker.cfg"
      double occ_trick_high;
//#line 63 "../cfg/ObjectTracker.cfg"
      double plane_tolerance;
//#line 69 "../cfg/ObjectTracker.cfg"
      double object_plane_percentage;
//#line 75 "../cfg/ObjectTracker.cfg"
      int object_ransac_iterations;
//#line 138 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"

    bool __fromMessage__(dynamic_reconfigure::Config &msg)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      int count = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        if ((*i)->fromMessage(msg, *this))
          count++;
      if (count != dynamic_reconfigure::ConfigTools::size(msg))
      {
        ROS_ERROR("ObjectTrackerConfig::__fromMessage__ called with an unexpected parameter.");
        ROS_ERROR("Booleans:");
        for (unsigned int i = 0; i < msg.bools.size(); i++)
          ROS_ERROR("  %s", msg.bools[i].name.c_str());
        ROS_ERROR("Integers:");
        for (unsigned int i = 0; i < msg.ints.size(); i++)
          ROS_ERROR("  %s", msg.ints[i].name.c_str());
        ROS_ERROR("Doubles:");
        for (unsigned int i = 0; i < msg.doubles.size(); i++)
          ROS_ERROR("  %s", msg.doubles[i].name.c_str());
        ROS_ERROR("Strings:");
        for (unsigned int i = 0; i < msg.strs.size(); i++)
          ROS_ERROR("  %s", msg.strs[i].name.c_str());
        // @todo Check that there are no duplicates. Make this error more
        // explicit.
        return false;
      }
      return true;
    }

    // This version of __toMessage__ is used during initialization of
    // statics when __getParamDescriptions__ can't be called yet.
    void __toMessage__(dynamic_reconfigure::Config &msg, const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__) const
    {
      dynamic_reconfigure::ConfigTools::clear(msg);
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toMessage(msg, *this);
    }
    
    void __toMessage__(dynamic_reconfigure::Config &msg) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      __toMessage__(msg, __param_descriptions__);
    }
    
    void __toServer__(const ros::NodeHandle &nh) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->toServer(nh, *this);
    }

    void __fromServer__(const ros::NodeHandle &nh)
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->fromServer(nh, *this);
    }

    void __clamp__()
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      const ObjectTrackerConfig &__max__ = __getMax__();
      const ObjectTrackerConfig &__min__ = __getMin__();
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->clamp(*this, __max__, __min__);
    }

    uint32_t __level__(const ObjectTrackerConfig &config) const
    {
      const std::vector<AbstractParamDescriptionConstPtr> &__param_descriptions__ = __getParamDescriptions__();
      uint32_t level = 0;
      for (std::vector<AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        (*i)->calcLevel(level, config, *this);
      return level;
    }
    
    static const dynamic_reconfigure::ConfigDescription &__getDescriptionMessage__();
    static const ObjectTrackerConfig &__getDefault__();
    static const ObjectTrackerConfig &__getMax__();
    static const ObjectTrackerConfig &__getMin__();
    static const std::vector<AbstractParamDescriptionConstPtr> &__getParamDescriptions__();
    
  private:
    static const ObjectTrackerConfigStatics *__get_statics__();
  };
  
  template <> // Max and min are ignored for strings.
  inline void ObjectTrackerConfig::ParamDescription<std::string>::clamp(ObjectTrackerConfig &config, const ObjectTrackerConfig &max, const ObjectTrackerConfig &min) const
  {
    return;
  }

  class ObjectTrackerConfigStatics
  {
    friend class ObjectTrackerConfig;
    
    ObjectTrackerConfigStatics()
    {
//#line 14 "../cfg/ObjectTracker.cfg"
      __min__.canonical_frame = "";
//#line 14 "../cfg/ObjectTracker.cfg"
      __max__.canonical_frame = "";
//#line 14 "../cfg/ObjectTracker.cfg"
      __default__.canonical_frame = "/map";
//#line 14 "../cfg/ObjectTracker.cfg"
      __param_descriptions__.push_back(ObjectTrackerConfig::AbstractParamDescriptionConstPtr(new ObjectTrackerConfig::ParamDescription<std::string>("canonical_frame", "str", 0, "The frame in which we work. Should be smart about odometry.", "", &ObjectTrackerConfig::canonical_frame)));
//#line 20 "../cfg/ObjectTracker.cfg"
      __min__.false_color = 0;
//#line 20 "../cfg/ObjectTracker.cfg"
      __max__.false_color = 1;
//#line 20 "../cfg/ObjectTracker.cfg"
      __default__.false_color = 0;
//#line 20 "../cfg/ObjectTracker.cfg"
      __param_descriptions__.push_back(ObjectTrackerConfig::AbstractParamDescriptionConstPtr(new ObjectTrackerConfig::ParamDescription<bool>("false_color", "bool", 0, "False-color the individual objects.", "", &ObjectTrackerConfig::false_color)));
//#line 26 "../cfg/ObjectTracker.cfg"
      __min__.send_boxes = 0;
//#line 26 "../cfg/ObjectTracker.cfg"
      __max__.send_boxes = 1;
//#line 26 "../cfg/ObjectTracker.cfg"
      __default__.send_boxes = 0;
//#line 26 "../cfg/ObjectTracker.cfg"
      __param_descriptions__.push_back(ObjectTrackerConfig::AbstractParamDescriptionConstPtr(new ObjectTrackerConfig::ParamDescription<bool>("send_boxes", "bool", 0, "Send the not-quite-bounding boxes.", "", &ObjectTrackerConfig::send_boxes)));
//#line 32 "../cfg/ObjectTracker.cfg"
      __min__.cluster_tolerance = 0.001;
//#line 32 "../cfg/ObjectTracker.cfg"
      __max__.cluster_tolerance = 1.0;
//#line 32 "../cfg/ObjectTracker.cfg"
      __default__.cluster_tolerance = 0.03;
//#line 32 "../cfg/ObjectTracker.cfg"
      __param_descriptions__.push_back(ObjectTrackerConfig::AbstractParamDescriptionConstPtr(new ObjectTrackerConfig::ParamDescription<double>("cluster_tolerance", "double", 0, "Euclidean cluster tolerance", "", &ObjectTrackerConfig::cluster_tolerance)));
//#line 38 "../cfg/ObjectTracker.cfg"
      __min__.min_cluster_size = 1;
//#line 38 "../cfg/ObjectTracker.cfg"
      __max__.min_cluster_size = 1000;
//#line 38 "../cfg/ObjectTracker.cfg"
      __default__.min_cluster_size = 150;
//#line 38 "../cfg/ObjectTracker.cfg"
      __param_descriptions__.push_back(ObjectTrackerConfig::AbstractParamDescriptionConstPtr(new ObjectTrackerConfig::ParamDescription<int>("min_cluster_size", "int", 0, "Minimum (object) cluster size", "", &ObjectTrackerConfig::min_cluster_size)));
//#line 44 "../cfg/ObjectTracker.cfg"
      __min__.max_cluster_size = 1;
//#line 44 "../cfg/ObjectTracker.cfg"
      __max__.max_cluster_size = 100000;
//#line 44 "../cfg/ObjectTracker.cfg"
      __default__.max_cluster_size = 10000;
//#line 44 "../cfg/ObjectTracker.cfg"
      __param_descriptions__.push_back(ObjectTrackerConfig::AbstractParamDescriptionConstPtr(new ObjectTrackerConfig::ParamDescription<int>("max_cluster_size", "int", 0, "Minimum (object) cluster size", "", &ObjectTrackerConfig::max_cluster_size)));
//#line 50 "../cfg/ObjectTracker.cfg"
      __min__.occ_trick_low = 0.0;
//#line 50 "../cfg/ObjectTracker.cfg"
      __max__.occ_trick_low = 1000.0;
//#line 50 "../cfg/ObjectTracker.cfg"
      __default__.occ_trick_low = 1.75;
//#line 50 "../cfg/ObjectTracker.cfg"
      __param_descriptions__.push_back(ObjectTrackerConfig::AbstractParamDescriptionConstPtr(new ObjectTrackerConfig::ParamDescription<double>("occ_trick_low", "double", 0, "Low z-threshold for the occupancy trick.", "", &ObjectTrackerConfig::occ_trick_low)));
//#line 56 "../cfg/ObjectTracker.cfg"
      __min__.occ_trick_high = 0.0;
//#line 56 "../cfg/ObjectTracker.cfg"
      __max__.occ_trick_high = 1000.0;
//#line 56 "../cfg/ObjectTracker.cfg"
      __default__.occ_trick_high = 10.0;
//#line 56 "../cfg/ObjectTracker.cfg"
      __param_descriptions__.push_back(ObjectTrackerConfig::AbstractParamDescriptionConstPtr(new ObjectTrackerConfig::ParamDescription<double>("occ_trick_high", "double", 0, "High z-threshold for the occupancy trick.", "", &ObjectTrackerConfig::occ_trick_high)));
//#line 63 "../cfg/ObjectTracker.cfg"
      __min__.plane_tolerance = 0.001;
//#line 63 "../cfg/ObjectTracker.cfg"
      __max__.plane_tolerance = 1.0;
//#line 63 "../cfg/ObjectTracker.cfg"
      __default__.plane_tolerance = 0.01;
//#line 63 "../cfg/ObjectTracker.cfg"
      __param_descriptions__.push_back(ObjectTrackerConfig::AbstractParamDescriptionConstPtr(new ObjectTrackerConfig::ParamDescription<double>("plane_tolerance", "double", 0, "Distance Threshold for plane fitter.", "", &ObjectTrackerConfig::plane_tolerance)));
//#line 69 "../cfg/ObjectTracker.cfg"
      __min__.object_plane_percentage = 0.0;
//#line 69 "../cfg/ObjectTracker.cfg"
      __max__.object_plane_percentage = 1.0;
//#line 69 "../cfg/ObjectTracker.cfg"
      __default__.object_plane_percentage = 0.9;
//#line 69 "../cfg/ObjectTracker.cfg"
      __param_descriptions__.push_back(ObjectTrackerConfig::AbstractParamDescriptionConstPtr(new ObjectTrackerConfig::ParamDescription<double>("object_plane_percentage", "double", 0, "What percentage of an object must fit a plane for it to not count?", "", &ObjectTrackerConfig::object_plane_percentage)));
//#line 75 "../cfg/ObjectTracker.cfg"
      __min__.object_ransac_iterations = 1;
//#line 75 "../cfg/ObjectTracker.cfg"
      __max__.object_ransac_iterations = 1000;
//#line 75 "../cfg/ObjectTracker.cfg"
      __default__.object_ransac_iterations = 10;
//#line 75 "../cfg/ObjectTracker.cfg"
      __param_descriptions__.push_back(ObjectTrackerConfig::AbstractParamDescriptionConstPtr(new ObjectTrackerConfig::ParamDescription<int>("object_ransac_iterations", "int", 0, "How much RANSAC to do when finding planes-pretending-to-be-objects", "", &ObjectTrackerConfig::object_ransac_iterations)));
//#line 239 "/opt/ros/electric/stacks/driver_common/dynamic_reconfigure/templates/ConfigType.h"
    
      for (std::vector<ObjectTrackerConfig::AbstractParamDescriptionConstPtr>::const_iterator i = __param_descriptions__.begin(); i != __param_descriptions__.end(); i++)
        __description_message__.parameters.push_back(**i);
      __max__.__toMessage__(__description_message__.max, __param_descriptions__); 
      __min__.__toMessage__(__description_message__.min, __param_descriptions__); 
      __default__.__toMessage__(__description_message__.dflt, __param_descriptions__); 
    }
    std::vector<ObjectTrackerConfig::AbstractParamDescriptionConstPtr> __param_descriptions__;
    ObjectTrackerConfig __max__;
    ObjectTrackerConfig __min__;
    ObjectTrackerConfig __default__;
    dynamic_reconfigure::ConfigDescription __description_message__;
    static const ObjectTrackerConfigStatics *get_instance()
    {
      // Split this off in a separate function because I know that
      // instance will get initialized the first time get_instance is
      // called, and I am guaranteeing that get_instance gets called at
      // most once.
      static ObjectTrackerConfigStatics instance;
      return &instance;
    }
  };

  inline const dynamic_reconfigure::ConfigDescription &ObjectTrackerConfig::__getDescriptionMessage__() 
  {
    return __get_statics__()->__description_message__;
  }

  inline const ObjectTrackerConfig &ObjectTrackerConfig::__getDefault__()
  {
    return __get_statics__()->__default__;
  }
  
  inline const ObjectTrackerConfig &ObjectTrackerConfig::__getMax__()
  {
    return __get_statics__()->__max__;
  }
  
  inline const ObjectTrackerConfig &ObjectTrackerConfig::__getMin__()
  {
    return __get_statics__()->__min__;
  }
  
  inline const std::vector<ObjectTrackerConfig::AbstractParamDescriptionConstPtr> &ObjectTrackerConfig::__getParamDescriptions__()
  {
    return __get_statics__()->__param_descriptions__;
  }

  inline const ObjectTrackerConfigStatics *ObjectTrackerConfig::__get_statics__()
  {
    const static ObjectTrackerConfigStatics *statics;
  
    if (statics) // Common case
      return statics;

    boost::mutex::scoped_lock lock(dynamic_reconfigure::__init_mutex__);

    if (statics) // In case we lost a race.
      return statics;

    statics = ObjectTrackerConfigStatics::get_instance();
    
    return statics;
  }


}

#endif // __OBJECTTRACKERRECONFIGURATOR_H__
