/*
 * test_miniatureoccupancygrid.cc
 * Mac Mason <mmason@willowgarage.com>
 *
 * Because testing makes me happy.
 */

#include <iostream>
#include <gtest/gtest.h>
#include "semanticmodel/miniatureoccupancygrid.hh"

using semanticmodel::MiniatureOccupancyGrid;

TEST(MiniOG, constructor)
{
  MiniatureOccupancyGrid og;
  EXPECT_DOUBLE_EQ(0.05, og._scale);

  EXPECT_EQ(0, og.grid.size());
}

TEST(MiniOG, getOnZero)
{
  MiniatureOccupancyGrid og;
  for (double i = 0 ; i < 100.0 ; i += 0.5)
  {
    for (double j = 0 ; j < 100.0 ; j += 0.5)
    {
      EXPECT_EQ(og.get(i, j), MiniatureOccupancyGrid::EMPTY);
    }
  }
}

TEST(MiniOG, set)
{
  MiniatureOccupancyGrid og;
  og.set(19.5, 20.5, MiniatureOccupancyGrid::OCCUPIED);
  EXPECT_EQ(og.get(19.5, 20.5), MiniatureOccupancyGrid::OCCUPIED);
  for (double i = 0 ; i < 19.0 ; i += 0.1)
  {
    EXPECT_EQ(og.grid.at((int)i).size(), 0);
  }
  EXPECT_EQ(og.grid.at(19).size(), 21);
  for (double i = 0 ; i < 19 ; i += 0.1)
  {
    for (double j = 0 ; j < 20 ; j += 0.1)
    {
      EXPECT_EQ(og.get(i, j), MiniatureOccupancyGrid::EMPTY);
    }
  }
}

int main(int argc, char* argv[])
{
  testing::InitGoogleTest(&argc, argv);
  return RUN_ALL_TESTS();
}
